﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using QFrameworkCP;

namespace JXSoft {
    //通讯协议管理，目前仅做独立通讯，后续会增加多线通讯
    public class ProtocolSettingsModel : AbstractModel, ICanGetModel
    {
        protected override void OnInit()
        {
            
        }
        private ProtocolType_ protocolType = ProtocolType_.NOPROTOCOL;
        public DataEventModel getProtocol()
        {
            switch (protocolType)
            {
                case (ProtocolType_.TCP):
                    return this.GetModel<TCPClientModel>();
                case (ProtocolType_.UDP):
                    return this.GetModel<UDPClientModel>();
                default:
                    return this.GetModel<TCPClientModel>();
            }
        }
        public void setProtocol(ProtocolType_ type)
        {
            protocolType = type;
            this.SendEvent(new OnProtocolSet(type));
        }
    }

    [SerializeField]
    public enum ProtocolType_
    {
        NOPROTOCOL = 0,
        TCP = 1,
        UDP = 2,
    }
    public struct OnProtocolSet
    {
        public ProtocolType_ type;
        public OnProtocolSet(ProtocolType_ type_)
        {
            type = type_;
        }
    }

}
